<?php 

// class.authorizenet.php 

/* 
    Copyright (C) 2003 Adam Olsen 

    This program is free software; you can redistribute it and/or modify 
    it under the terms of the GNU General Public License as published by 
    the Free Software Foundation; either version 1, or (at your option) 
    any later version. 

    This program is distributed in the hope that it will be useful, 
    but WITHOUT ANY WARRANTY; without even the implied warranty of 
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
    GNU General Public License for more details. 

    You should have received a copy of the GNU General Public License 
    along with this program; if not, write to the Free Software 
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
*/ 

/************************************************************************ 
*                                                                       * 
*  Requirements:  PHP4, cURL, SSL                                       * 
*  I have tested this class on a slackware linux system, although       * 
*  I don't see any reason why it shouldn't work on other UNIX based     * 
*  systems.                                                             * 
*                                                                       * 
*  It only requires that cURL is installed on the command line - this   * 
*  is useful if you cannot compile cURL into PHP itself.                * 
*                                                                       * 
*  Credits:  I based this class on an echo interface class I found on   * 
*  zend.com                                                             * 
*                                                                       * 
************************************************************************/ 


class AuthorizeNet 
{ 
    var $loginId; 
    var $version; 
    var $customerEmail; 
    var $address; 
    var $city; 
    var $state; 
    var $zip; 
    var $phone; 
    var $country; 
    var $ADC_URL; 
    var $type; 
    var $method; 
    var $firstName; 
    var $lastName; 
    var $amount; 
    var $cardNumber; 
    var $expireDate; 
    var $script; 
    var $port; 
    var $ADC_Delim_Char; 
    var $error; 
    var $Bank_ABA_Code; 
    var $Bank_Acct_Num; 
    var $Bank_Name; 
     
    function authorizenet() 
    { 
        //check for curl 
        if( !is_file( "/usr/bin/curl" ) ) die( "Authorizenet Class Fatal Error: Could not locate cURL in /usr/bin ." ); 
     
        //set up the defaults 
        $this->version = "3"; 
        $this->type = "AUTH_CAPTURE"; 
        $this->Method = "CC"; //the default is for credit card responses 
        $this->script = "https://secure.authorize.net/gateway/transact.dll"; 
        $this->port = 443; 
    } 
     
    function process() 
    { 
        $data = $this->getUrlData(); //get the data to send 
        exec( "/usr/bin/curl -d \"$data\" $this->script", $returnArray ); //run curl with the data 
         
        $returnString = ""; 
        foreach( $returnArray as $item ) $returnString .= $item; 
         
        $returnArray = array(); 
        $returnArray = explode( '|', $returnString ); 
        $responseCode = $returnArray[2]; 
        if( $responseCode == 1 ) return true; //if the process was successfull 
        else 
        { 
            if( $returnArray[3] ) $this->error = $returnArray[3]; 
            //if the process was unsucsessfull, tell why 
            else $this->error = $returnString; 
             
            return false; 
        } 
    } 
     
    function error() //return the error code from processing 
    { 
        return $this->error; 
    } 
     
    function getUrlData() 
    { 
        $data .= 
        "x_Login="                    . $this->loginId .  //the login id 
        "&x_ADC_Delim_Data="          . "TRUE" . //make it ADC 
        "&x_ADC_Delim_Character="     . "|" . //the character to delim by 
        "&x_ADC_URL="                 . "FALSE" . 
        "&x_Email_Customer="          . $this->customerEmail . 
        "&x_Address="                 . $this->address . 
        "&x_City="                    . $this->city . 
        "&x_State="                   . $this->state . 
        "&x_Zip="                     . $this->zip . 
        "&x_Country="                 . $this->country . 
        "&x_Phone="                   . $this->phone . 
        "&x_Type="                    . $this->type . 
        "&x_Method="                  . $this->method . 
        "&x_First_Name="              . $this->firstName . 
        "&x_Last_Name="               . $this->lastName . 
        "&x_Amount="                  . $this->amount; 
         
        if( $this->method == "CC" ) //if it is a credit card transaction 
        { 
            $data .= 
            "&x_Card_Num="                . $this->cardNumber . 
            "&x_Exp_Date="                . $this->expireDate; 
        } 
         
        if( $this->method == "ECHECK" ) //if it is a check transaction 
        { 
            $data .= 
            "&x_Bank_ABA_Code="           . $this->Bank_ABA_Code . 
            "&x_Bank_Acct_Num="           . $this->Bank_Acct_Num . 
            "&x_Bank_Name="               . $this->Bank_Name; 
        } 

        return $data; 
    } 
     
    //each field must be urlencoded to send with a post.  DO NOT set the variables without using these functions, as you will most 
    //likely run into errors 
     
    function setRoutingNumber( $number ) 
    { 
        $this->Bank_ABA_Code = urlencode( $number ); 
    } 
     
    function setBankAccountNumber( $number ) 
    { 
        $this->Bank_Acct_Num = urlencode( $number ); 
    } 
     
    function setBankName( $name ) 
    { 
        $this->Bank_Name = urlencode( $name ); 
    } 
     
    function setMethod( $method ) 
    { 
        $this->method = $method; 
    } 
     
    function setLoginId( $loginId ) 
    { 
        $this->loginId = urlencode( $loginId ); 
    } 
     
    function setCustomerEmail( $customerEmail ) 
    { 
        $this->customerEmail = urlencode( $customerEmail ); 
    } 
     
    function setAddress( $address ) 
    { 
        $this->address = urlencode( $address ); 
    } 
     
    function setCity( $city ) 
    { 
        $this->city = urlencode( $city ); 
    } 
     
    function setState( $state ) 
    { 
        $this->state = urlencode( $state ); 
    } 
     
    function setZip( $zip ) 
    { 
        $this->zip = urlencode( $zip ); 
    } 
     
    function setCountry( $country ) 
    { 
        $this->country = urlencode( $country ); 
    } 
     
    function setPhone( $phone ) 
    { 
        $this->phone = urlencode( $phone ); 
    } 
     
    function setFirstName( $name ) 
    { 
        $this->firstName = urlencode( $name ); 
    } 
     
    function setLastName( $name ) 
    { 
        $this->lastName = urlencode( $name ); 
    } 
     
    function setAmount( $amount ) 
    { 
        $this->amount = urlencode( $amount ); 
    } 
     
    function setCardNumber( $number ) 
    { 
        $this->cardNumber = urlencode( $cardNumber ); 
    } 
     
    function setExpireDate( $date ) 
    { 
        $this->expireDate = urlencode( $date ); 
    } 
}; 

?>  
Example  
<? 

//a script to test the authorizenet class 

include( "class.authorizenet.php" ); 

$auth = new AuthorizeNet(); 

$auth->setLoginId( "yourLoginId" ); //change this to your authorize.net login Id 
$auth->setCustomerEmail( "adamolsen@net-bizz.com" ); //set this to the customers email address 
$auth->setAddress( "5309 Cyclamen Way" );   
$auth->setCity( "West Jordan" ); 
$auth->setState( "UT" ); 
$auth->setZip( "84084" ); 
$auth->setCountry( "USA" ); 
$auth->setPhone( "967-2539" ); 
$auth->setFirstName( "Adam" ); 
$auth->setLastName( "Olsen" ); 
$auth->setAmount( "12.00" ); 
$auth->setCardNumber( "4222222222222222" ); 
$auth->setExpireDate( "0303" ); 

//authorizenet->process() will return true if the transaction was a success, false if it is not. 
//if it is not a success, authorizenet->error() will return the error message from their server 

if( !$auth->process() ) print "Error: " . $auth->error(); 

exit; 
?>