<? 
/******************************************************************* 
* 
*    DESCRIPTION: Get weather from Weather.com based on ZIP code 
*        and store it in a database so we dont have to 
*        query weather.com everytime the page loads. 
* 
*    AUTHOR: Brad King - KingTechSolutions 
*         http://kingtechsolutions.com 
* 
*    HISTORY: Ver 1.0    - Dec 16, 2001 
*        (Will probably require udates as weather.com 
*        changes page architecture) 
* 
*    HISTORY: Ver 1.1    - Jun 19, 2002 
*              (As suspected weather.com 
*              changed page architecture) 
* 
*    HISTORY: Ver 1.2    - Nov 25, 2002 
*              (As suspected weather.com 
*              changed page architecture again) 
* 
*    HISTORY: Ver 1.3    - Jan 13, 2003 
*              (changed page architecture) 
* 
*    HISTORY: Ver 1.4    - Jun 17, 2003 
*              URL Change: 
*              http://www.w3.weather.com/weather/local/$zipCode 
* 
*******************************************************************/ 

/*--------------------------------- 
    Interval DB is updated from 
    Weather.com - 3600 is One Hour 
    Unix Time 
---------------------------------*/ 
$zipCode = "37201"; 
$CheckInterval = 3600; // 3600; 
$CacheHistory = 5; // Number of days to cache weather data 
$imgPath = "./wimg"; // Path to images 
$TblWidth = 200; // Width of output Table 

/*--------------------------------- 
    Is this file an include for 
    another file ? If so set to 
    1 and the header and body 
    tags will not be included. 
---------------------------------*/ 
$is_include = 0; 

/*--------------------------------- 
    MySQL DB Connection info 
---------------------------------*/ 
$dbhost = "localhost"; 
$dbuser = "dbuser"; 
$dbpass = "dbhost"; 
$dbname = "dbname"; 

/******************************************************************* 
    INSTALL NOTES: 

    1) Create an img subfolder and make world writable, 
        (e.g. 
            $> mkdir img 
            $> chmod 0777 img 
        ) 

        This is where the graphic image is written to. So that 
        when reading the data from the DB. weather.com is 
        does not have to be contactd to place the image. 

    2) Use the Following Table structure to Create the Table. 

    # 
    # Table structure for table `weather` 
    # 

    CREATE TABLE weather ( 
      id int(11) NOT NULL auto_increment, 
      currStat varchar(250) NOT NULL default '', 
      FeelsLike varchar(200) NOT NULL default '', 
      UVIndex varchar(200) NOT NULL default '', 
      Wind varchar(200) NOT NULL default '', 
      DewPoint varchar(200) NOT NULL default '', 
      Humidity varchar(200) NOT NULL default '', 
      Visibility varchar(200) NOT NULL default '', 
      Barometer varchar(150) NOT NULL default '', 
      Report tinytext NOT NULL, 
      date datetime NOT NULL default '0000-00-00 00:00:00', 
      zipCode int(5) NOT NULL default '0', 
      PRIMARY KEY  (id), 
      KEY id (id) 
    ) TYPE=MyISAM; 

*******************************************************************/ 

/* 
** mysql_dt_to_human 
* 
* 
*  PARAMETERS: A MySQL formatted DateTime 
* 
*  DESCRIPTION: Returns a Unix Timestamp from a MySQL Date 
* 
*  RETURNS: Unix Timestamp 
* 
*/ 

function mysql_dt_to_human($dt) { 
    //intercept mysql's default ZERO date value. 
    if ($dt=="0000-00-00 00:00:00") return ""; 
    $yr=strval(substr($dt,0,4)); 
    $mo=strval(substr($dt,5,2)); 
    $da=strval(substr($dt,8,2)); 
    $hr=strval(substr($dt,11,2)); 
    $mi=strval(substr($dt,14,2)); 
    $se=strval(substr($dt,17,2)); 

    return mktime($hr,$mi,$se,$mo,$da,$yr); 
} 

/* 
** cleanup_cache 
* 
* 
*  PARAMETERS: A MySQL formatted DateTime, and Image Path 
* 
*  DESCRIPTION: Clean up older images and SQL data 
* 
*  RETURNS: Unix Timestamp 
* 
*/ 

function cleanup_cache ($CacheHistory, $imgPath) { 
    $CacheHistory = 86400 * $CacheHistory; 
    $TimeNow = mktime(); 
    /*------------------------------------- 
    Now clean up database and delete older 
    images. 
    -------------------------------------*/ 
    $sql = "SELECT * FROM weather"; 
    $result = mysql_query($sql) or 
                  die ( mysql_error() ); 
    $myrow = mysql_fetch_array($result); 

        do { 
            $date = $myrow['date']; 
            $WeatherAge =  mysql_dt_to_human($date); 
            $HowOld = $TimeNow - $WeatherAge; 

            if ($HowOld > $CacheHistory) { 
                // Delete from DB 
                $sql = "DELETE FROM weather WHERE date = '$date'"; 
                $CleanCache = mysql_query($sql) or 
                      die ( mysql_error() ); 
                // Delete Image 
                if (file_exists("$imgPath/$WeatherAge.gif")) { 
                    unlink("$imgPath/$WeatherAge.gif"); 
                } 
            } 
        } while ($myrow = mysql_fetch_array($result)); 
} 

function data_drop () { 
    $sql = "SELECT id,date FROM weather ORDER BY DATE DESC"; 
    $result = mysql_query($sql) or 
                  die ( mysql_error() ); 
    $myrow = mysql_fetch_array($result); 
        print("<SELECT NAME=GetCache CLASS=kingtech><OPTION VALUE=>Archived Weather"); 
        do { 
            $date = date("M d H:i:s", mysql_dt_to_human($myrow[1])); 
            $id = $myrow[0]; 
            print("<OPTION VALUE=$id>$date"); 

        } while ($myrow = mysql_fetch_array($result)); 
        print("</SELECT>"); 
} 


/******************************************************************* 
*      Start The Script Now 
*******************************************************************/ 

$url = "http://www.w3.weather.com/weather/local/$zipCode"; 
/* Connect to Databse */ 
$db = mysql_connect("$dbhost", "$dbuser", "$dbpass") 
        or die ("Unable to connect to database $dbname."); 
mysql_select_db("$dbname",$db) 
        or die ("Unable to Select DataBase $dbname."); 

// Check Date and Zip 
$sql = "SELECT date,zipCode from weather"; 
$result = mysql_query($sql) or 
              die ( mysql_error() ); 

$numrows = mysql_num_rows($result); 
if ($numrows != 0) { 
    mysql_data_seek ($result, $numrows - 1); 
    $myrow = mysql_fetch_row($result); 
    $TimeNow = mktime(); 
    $WeatherAge =  mysql_dt_to_human($myrow[0]); 
    $WeatherAge = $TimeNow - $WeatherAge; 
} else { 
    //Force a check no data in DB 
    $WeatherAge = $WeatherAge * 4; 
} 

if ($is_include != 1) { 
    echo "<HTML>"; 
    echo "<HEAD>"; 
    echo "<TITLE>Current Weather ($zipCode)</TITLE>"; 
    echo "</HEAD>"; 
    echo "<BODY>"; 
} 

echo "<style TYPE=\"text/css\"> 
        TD.wthr  { 
            color: #000066; 
            font-family :Tahoma, Verdana, Arial; 
            font-size :12px; 
            font-weight :BOLD; 
            background-color : #98B6F0; 
            border : 1px solid Black; 
        } 
        TD.wthr1  { 
            color: #000066; 
            font-family :Tahoma, Verdana, Arial; 
            font-size :10px; 
            font-weight :BOLD; 
        } 
        TD.wthr2  { 
            font-family :Tahoma, Verdana, Arial; 
            font-size :10px; 
        } 
        TD.report  { 
            font-family :Tahoma, Verdana, Arial; 
            font-size :9px; 
        } 
        TD.kingtech  { 
            font-family :Tahoma, Verdana, Arial; 
            font-size :9px; 
            background-color : #98B6F0; 
            border : 1px solid Black; 
            text-decoration : none; 
        } 

        A.kingtech, A.kingtech:LINK, A.kingtech:VISITED  { 
            color: #666666; 
            font-family :Tahoma, Verdana, Arial; 
            font-size :9px; 
            text-decoration : none; 
        } 
        SELECT.kingtech { 
            font-size : 10px; 
            font-family :Tahoma, Verdana, Arial; 
            font-size :10px; 
        } 
        INPUT.gobutton { 
            font-size : 10px; 
            font-family :Tahoma, Verdana, Arial; 
            font-size :10px; 
        } 
        </style>"; 
echo "<TABLE ALIGN=CENTER BORDER=0 width=$TblWidth>"; 

// Error Checking on ZIp COde Length 
if (strlen($zipCode) != 5) { 
    echo "<TR><TD class=wthr>Invalid Zip Code</TD></TR></TABLE>"; 
    die; 
} 
/*----------------------------------------------- 
    If Weather in SQL DB is not older than 
    var CheckInterval or the zip code has not 
    changed. Then query from database. 
    If it not grab from weather.com 
------------------------------------------------*/ 
if ($submit and !empty($GetCache)) { 
    $WeatherAge = 1; 
} 

if ($WeatherAge < $CheckInterval xor $zipCode != $myrow[1]) { 
    if ($submit and !empty($GetCache)) { 
        $sql = "SELECT * from weather WHERE id=$GetCache"; 
        $result = mysql_query($sql) or 
                      die ( mysql_error() ); 
    } else { 
        $sql = "SELECT * from weather"; 
        $result = mysql_query($sql) or 
                      die ( mysql_error() ); 

        $numrows = mysql_num_rows($result); 
        mysql_data_seek ($result, $numrows - 1); 
    } 

    $myrow = mysql_fetch_row($result); 

    $currStat = $myrow[1]; 
    $FeelsLike = $myrow[2]; 
    $UVIndex = $myrow[3]; 
    $Wind = $myrow[4]; 
    $DewPoint = $myrow[5]; 
    $Humidity = $myrow[6]; 
    $Visibility = $myrow[7]; 
    $Barometer = $myrow[8]; 
    $Report = $myrow[9]; 
    $dateIcon = mysql_dt_to_human($myrow[10]); 

    $CacheDate = date("M d, Y H:i:s T", $dateIcon); 
    $SQLcache = "(Cached - $CacheDate)"; 


} else { 
    $SQLcache = "(Updated)"; 
    $dateIcon = mktime(); 
    $fp = @fopen($url,"r"); 
    if (!$fp) { 
        echo "<TR><TD class=wthr>Invalid Zip Code or file does not exist</TD></TR></TABLE>"; 
        die; 
    } 

            $urlfile = file($url); 
            $string = implode("\n", $urlfile); 
            /*------------------------------------- 
            Write the Image to a File for use when 
            we pull from SQL Data not weather.com 
            Make an img/ folder and make writable 
            -------------------------------------*/ 

            $WeatherIcon = "CLASS=obsInfo1"; 
            $WeatherReport = 'CLASS=obsTextA>'; 
            $WeatherTemp = 'CLASS=obsTempTextA>'; 
                         
            $icon = explode($WeatherIcon, $string); 
             
            $icon = explode("SRC=", $icon[1]); 
            $icon = $icon[1];             

            $imgFile = explode("WIDTH=", $icon); 
            $imgFile = $imgFile[0]; 
             
             
             
            $handle = fopen ($imgFile, "r"); 
            $outhandle=fopen ("$imgPath/$dateIcon.gif","w"); 
            while (!feof($handle)) { 
                $buffer=fread($handle,4096); 
                fputs($outhandle,$buffer); 
            } 
            fclose($handle); 
            fclose($outhandle); 
             


            // Get Weather Data 
            $StdObs = 'CLASS=obsInfo2>'; 
             
            $CurrFcst = explode($WeatherReport, $string); 
            $CurrFcst = explode("</TD>", $CurrFcst[1]); 
            $CurrFcst = trim(strip_tags($CurrFcst[0])); 

             
            $CurrTemp = explode($WeatherTemp, $string); 
            $CurrTemp = explode("\n", $CurrTemp[1]); 
            $CurrTemp = trim(strip_tags($CurrTemp[0])); 

            $currStat = "$CurrFcst $CurrTemp"; 

            $FeelsLike = explode("Feels Like<BR>", $string); 
            $FeelsLike = explode("</TD>", $FeelsLike[1]); 
            $FeelsLike = trim(strip_tags($FeelsLike[0])); 

            $UVIndex = explode("UV Index:", $string); 
            $UVIndex = explode($StdObs, $UVIndex[1]); 
            $UVIndex = explode('</TD>', $UVIndex[1]); 
            $UVIndex = trim(strip_tags($UVIndex[0])); 

            $DewPoint = explode("Dew Point:", $string); 
            $DewPoint = explode($StdObs, $DewPoint[1]); 
            $DewPoint = explode('</TD>', $DewPoint[1]); 
            $DewPoint = trim(strip_tags($DewPoint[0])); 

            $Humidity = explode("Humidity:", $string); 
            $Humidity = explode($StdObs, $Humidity[1]); 
            $Humidity = explode('</TD>', $Humidity[1]); 
            $Humidity = trim(strip_tags($Humidity[0])); 

            $Visibility = explode("Visibility:", $string); 
            $Visibility = explode($StdObs, $Visibility[1]); 
            $Visibility = explode('</TD>', $Visibility[1]); 
            $Visibility = trim(strip_tags($Visibility[0])); 

            $Barometer = explode("Pressure:", $string); 
            $Barometer = explode($StdObs, $Barometer[1]); 
            $Barometer = explode('</TD>', $Barometer[1]); 
            $Barometer = trim(strip_tags($Barometer[0])); 

            $Wind = explode("Wind:", $string); 
            $Wind = explode($StdObs, $Wind[1]); 
            $Wind = explode('</TD>', $Wind[1]); 
            $Wind = trim(strip_tags($Wind[0])); 

            $Report = explode("As reported at", $string); 
            $Report = explode('</TD>', $Report[1]); 
            $Report = "As reported at ".trim(strip_tags(ucfirst($Report[0]))) 
             
            /*------------------------*/ 
            // Insert into SQL table 
            $SQLdate = date("Y-m-d H:i:s", $dateIcon); 
            $sql = "INSERT INTO weather VALUES ('', '$currStat','$FeelsLike','$UVIndex','$Wind','$DewPoint','$Humidity','$Visibility','$Barometer','$Report','$SQLdate','$zipCode')"; 
            $result = mysql_query($sql) or 
                      die ( mysql_error() );; 

} 

cleanup_cache ($CacheHistory, $imgPath); 

    /*------------------------------------- 
    We have all the info now show the Weather 
    -------------------------------------*/ 

echo "<TR><TD VALIGN=TOP colspan=2 align=center class=report><img src=$imgPath/$dateIcon.gif ALT='$CurrFcst' width=52 height=52 BORDER=0><br>$SQLcache</TD></TR>"; 
echo "<TR><TD VALIGN=TOP colspan=2 align=center class=wthr>$currStat</TD></TR>"; 
echo "<TR><TD VALIGN=TOP ALIGN=RIGHT class=wthr1>Feels Like:</TD><TD class=wthr2>$FeelsLike</TD></TR>"; 
echo "<TR><TD VALIGN=TOP ALIGN=RIGHT class=wthr1>UV Index:</TD><TD class=wthr2>$UVIndex</TD></TR>"; 
echo "<TR><TD VALIGN=TOP ALIGN=RIGHT class=wthr1>Wind:</TD><TD class=wthr2>$Wind</TD></TR>"; 
echo "<TR><TD VALIGN=TOP ALIGN=RIGHT class=wthr1>Dew Point:</TD><TD class=wthr2>$DewPoint</TD></TR>"; 
echo "<TR><TD VALIGN=TOP ALIGN=RIGHT class=wthr1>Humidity:</TD><TD class=wthr2>$Humidity</TD></TR>"; 
echo "<TR><TD VALIGN=TOP ALIGN=RIGHT class=wthr1>Visibility:</TD><TD class=wthr2>$Visibility</TD></TR>"; 
echo "<TR><TD VALIGN=TOP ALIGN=RIGHT class=wthr1>Barometer:</TD><TD class=wthr2>$Barometer</TD></TR>"; 
echo "<TR><TD VALIGN=TOP colspan=2 class=report>$Report</TD></TR>"; 

echo "<form>"; 
echo "<TR><TD VALIGN=TOP colspan=2 align=center>"; 
data_drop(); 
echo "&nbsp;<INPUT TYPE=Submit NAME=submit value=Go class=gobutton>"; 
echo "</TD></TR>"; 
echo "</form>"; 

echo "<TR><TD VALIGN=TOP colspan=2 align=center class=report>Forecast from <a href=$url target=_blank>Weather.com</a></TD></TR>"; 
echo "<TR><TD VALIGN=TOP colspan=2 align=center class=kingtech>Script developed by:<br><a href=\"http://kingtechsolutions.com\" target=_blank class=kingtech>KingTechSolutions</a></TD></TR>"; 
echo "</TABLE>"; 


?>